Option Explicit
Const adTypeBinary = 1
Const adTypeText   = 2

Sub SearchAccountStart
  Dim objRS, ctMembers
  Dim strResult, strButton

  If Len(txtObjectName.Value) < 1 Then
    strResult = "Ώۂw肵ĂB"
  Else
    strResult = ""
    ctMembers = 0
    ADOCommand.CommandText = "<LDAP://" & BaseDN & ">;" & _
	"(|(sAMAccountName=" & Left(txtObjectName.Value,20) & ")(cn=" & txtObjectName.Value & "));distinguishedName;subtree"
    Set objRS = ADOCommand.Execute
    Do Until objRS.EOF
      ctMembers = ctMembers + 1
      strButton = "<input type=""button"" value=""" & objRS.Fields("distinguishedName") & _
		""" onClick=""ShowSchema '" & objRS.Fields("distinguishedName") & "'"">"
      If ctMembers = 1 Then
        strResult = strButton
      ElseIf ctMembers > 100 Then
        strResult = strResult & "<br>100𒴂̂Œ~܂B"
        Exit Do
      Else
        strResult = strResult & "<br>" & strButton
      End If
      objRS.MoveNext
    Loop
    If ctMembers = 0 Then strResult = txtObjectName.Value & "͌܂łB"
  End If
  ExPage.innerHTML = "<div class=""con1"">" & strResult & "</div><div class=""con1"" id=""SchPage""></div>"
End Sub

Function GetStrData( strSchema, arrData )
  Dim strData, ct
  strData = ""
  If strSchema = "objectSid" Then
    strData = GetStringSID( arrData(0) )
  ElseIf strSchema = "objectGUID" Then
    strData = GetStringGID( arrData(0) )
  ElseIf strSchema = "badPasswordTime" Or _
     strSchema = "lastLogon" Or _
     strSchema = "lastLogoff" Or _
     strSchema = "lastLogonTimestamp" Or _
     strSchema = "pwdLastSet" Or _
     strSchema = "uSNChanged" Or _
     strSchema = "uSNCreated" Then
    strData = GetDateTime( arrData(0) )
  ElseIf UBound(arrData) >= 0 Then
    If VarType(arrData(0)) = vbString Or _
       VarType(arrData(0)) = vbDate Or _
       VarType(arrData(0)) = vbBoolean Or _
       VarType(arrData(0)) = vbLong Then
      For ct = 0 To UBound(arrData)
        If ct = 0 Then
          strData = arrData(ct)
        Else
          strData = strData & "<br>" & arrData(ct)
        End If
      Next
    End If
  End If
  GetStrData = strData
End Function

Function GetStringGID( rawBytes )
  Dim adStream, retStr
  Dim arrBytes, i, tmp

  Set adStream = CreateObject("ADODB.Stream")
  adStream.Type = adTypeText
  On Error Resume Next
  adStream.Charset = "UTF-16"
  On Error Goto 0
  adStream.Open
  adStream.WriteText rawBytes
  adStream.Position = 0
  adStream.Type = adTypeBinary
  adStream.Position = 2
  ReDim arrBytes(UBound(rawBytes))

  For i=0 to UBound(rawBytes)
    tmp = adStream.Read(1)
    If IsNull(tmp) Then Exit For
    arrBytes(i) = AscB(tmp)
  Next
  adStream.Close
  retStr = Right("0" & Hex(arrBytes(3)), 2) & Right("0" & Hex(arrBytes(2)), 2) & Right("0" & Hex(arrBytes(1)), 2) & Right("0" & Hex(arrBytes(0)), 2) & "-"
  retStr = retStr & Right("0" & Hex(arrBytes(5)), 2) &  Right("0" & Hex(arrBytes(4)), 2) & "-"
  retStr = retStr & Right("0" & Hex(arrBytes(7)), 2) &  Right("0" & Hex(arrBytes(6)), 2) & "-"
  retStr = retStr & Right("0" & Hex(arrBytes(8)), 2) &  Right("0" & Hex(arrBytes(9)), 2) & "-"
  For i = 10 To UBound(arrBytes)
    retStr = retStr & Right("0" & Hex(arrBytes(i)), 2)
  Next
  GetStringGID = LCase(retStr)
End Function

Function GetStringSID( rawSID )
  Dim retStr, arrSID
  Dim adStream, i, tmp, j
  retStr = "S-"

  Set adStream = CreateObject("ADODB.Stream")
  adStream.Type = adTypeText
  On Error Resume Next
  adStream.Charset = "UTF-16"
  On Error Goto 0
  adStream.Open
  adStream.WriteText rawSID
  adStream.Position = 0
  adStream.Type = adTypeBinary
  adStream.Position = 2
  ReDim arrSID(UBound(rawSID))

  For i=0 to UBound(rawSID)
    tmp = adStream.Read(1)
    If IsNull(tmp) Then Exit For
    arrSID(i) = AscB(tmp)
  Next
  adStream.Close

  retStr = retStr & arrSID(0) & "-" & arrSID(1)
  j = 3
  Do While UBound(arrSID) >= j * 4 - 1
    tmp = arrSID(j*4-1) * 256^3 + arrSID(j*4-2) * 256^2 + arrSID(j*4-3) * 256 + arrSID(j*4-4)
    j = j + 1
    retStr = retStr & "-" & tmp
  Loop

  GetStringSID = retStr
End Function

Sub ShowSchema( strDN )
  Dim objSchema, strSchema, objData, arrProp, strType, strData
  Dim strResult

  If Len(strDN) < 1 Then
    MsgBox "܂łB"
  Else
    Set objData = GetObject("LDAP://" & strDN)
    Set objSchema = GetObject(objData.Schema)
    strResult = strDN & _
		"<table style=""border: 1px solid #000;"">" & _
		"<tr><td></td><td>v</td><td>^</td><td>l</td></tr>"
    For Each strSchema In objSchema.MandatoryProperties
      strType = "(NULL)"
      strData = "(NULL)"
      On Error Resume Next
      arrProp = objData.GetEx(strSchema)
      If Err.Number = 0 Then
        On Error Goto 0
        strType = TypeName(arrProp(0))
        strData = GetStrData(strSchema, arrProp)
      End If
      On Error Goto 0
      strResult = strResult & "<tr><td>" & strSchema & "</td><td>K{</td><td>" & strType & "</td><td>" & strData & "</td></tr>"
    Next
    For Each strSchema In objSchema.OptionalProperties
      strType = "(NULL)"
      strData = "(NULL)"
      On Error Resume Next
      arrProp = objData.GetEx(strSchema)
      If Err.Number = 0 Then
        On Error Goto 0
        strType = TypeName(arrProp(0))
        If strSchema = "accountExpires" Then
          strData = objData.AccountExpirationDate
          ' If strData = #01/01/1970# Or strData = #01/01/1601 9:00:00# Then strData = ""
          If strData =< #01/01/1970# Then strData = ""
        Else
          strData = GetStrData(strSchema, arrProp)
        End If
      ElseIf Err.Number = E_ADS_PROPERTY_NOT_FOUND Then
        Err.Clear
        objData.GetInfoEx Array(strSchema), 0
        If Err.Number = 0 Then
          arrProp = objData.GetEx(strSchema)
          If Err.Number = 0 Then
            strType = TypeName(arrProp(0))
            strData = GetStrData(strSchema, arrProp)
          End If
        End If
      End If
      On Error Goto 0
      strResult = strResult & "<tr style='vertical-align:top;'><td>" & strSchema & "</td><td></td><td>" & strType & "</td><td>" & strData & "</td></tr>"
    Next
    strResult = strResult & "</table>"
  End If
  SchPage.innerHTML = strResult
End Sub

Sub SearchOUStart
  Dim objRS, strButton
  Dim strResult, ctMembers

  If Len(txtObjectName.Value) < 1 Then
    strResult = "Ώۂw肵ĂB"
  Else
    ADOCommand.CommandText = "<LDAP://" & BaseDN & ">;" & _
	"(&(objectClass=organizationalUnit)(ou=" & txtObjectName.Value & "));distinguishedName;subtree"
    Set objRS = ADOCommand.Execute
    strResult = ""
    ctMembers = 0
    Do Until objRS.EOF
      ctMembers = ctMembers + 1
      strButton = "<input type=""button"" value=""" & objRS.Fields("distinguishedName") & _
		""" onClick=""ShowSchema '" & objRS.Fields("distinguishedName") & "'"">"
      If ctMembers = 1 Then
        strResult = strButton
      ElseIf ctMembers > 100 Then
        strResult = strResult & "<br>100𒴂̂Œ~܂B"
        Exit Do
      Else
        strResult = strResult & "<br>" & strButton
      End If
      objRS.MoveNext
    Loop
    If ctMembers = 0 Then strResult = txtObjectName.Value & "͌܂łB"
  End If
  ExPage.innerHTML = "<div class=""con1"">" & strResult & "</div><div class=""con1"" id=""SchPage""</div>"
End Sub

Sub btnSearchObject_OnClick
  WorkPage.innerHTML =	"<div class=""top1"">IuWFNg</div>" & _
			"<div class=""con1"">" & _
			"<input type=""text"" name=""txtObjectName"" value="""" size=50>" & _
			"<input type=""button"" name=""btnSearchAccountGo"" value=""AJEg"" onClick=""SearchAccountStart"">" & _
			"<input type=""button"" name=""btnSearchOUGo"" value=""OU"" onClick=""SearchOUStart"">" & _
			"</div>"
  ChangePage("search")
End Sub

