Option Explicit
Const ForReading = 1, ForWriting = 2
Const evError = 1, evWarning = 2, evInfomation = 4
Const TemporaryFolder = 2
Const ADS_PROPERTY_CLEAR = 1
Const ADS_PROPERTY_UPDATE = 2
Const ADS_GROUP_TYPE_GLOBAL_GROUP = &h2
Const ADS_GROUP_TYPE_LOCAL_GROUP = &h4
Const ADS_GROUP_TYPE_UNIVERSAL_GROUP = &h8
Const ADS_GROUP_TYPE_SECURITY_ENABLED = &h80000000
Const E_ADS_PROPERTY_NOT_FOUND = &H8000500D
' Const ADS_UF_PASSWORD_EXPIRED = &h800000

Const fAction = "ACTION"
Const fUser = "USER"
Const fOU = "OU"
Const fPassword = "PASSWORD"
Const fGroup = "GROUP"
Const fActive = "ACTIVE"
Const fScope = "SCOPE"
Const fMember = "MEMBER"
Const fExpire = "EXPIRE"
' Const fChangePass = "CHANGEPASS"

Dim WshShell, FSO
Dim ADOConnection, ADOCommand, BaseDN, DomainName
Dim iTimerID, LogData, isUpdate
Dim SleepVBS
Dim BehaviorVersion(7), NativeOrMixed(1)

BehaviorVersion(0) = "Windows 2000 "
BehaviorVersion(1) = "Windows Server 2003 "
BehaviorVersion(2) = "Windows Server 2003"
BehaviorVersion(3) = "Windows Server 2008"
BehaviorVersion(4) = "Windows Server 2008 R2"
BehaviorVersion(5) = "Windows Server 2012"
BehaviorVersion(6) = "Windows Server 2012 R2"
BehaviorVersion(7) = "Windows Server 2016"
NativeOrMixed(0) = "lCeBu"
NativeOrMixed(1) = ""

' ŏ̉
Sub TopStatus
  Dim strTable
  ChangePage("status")
  strTable = "<div class=""top1""></div><table class=""con1"">"
  strTable = strTable & "<tr><td>o[W</td><td>" & objHTA.Version & "</td></tr>"
  strTable = strTable & "<tr><td>hC</td><td>" & GetDomainName & "</td></tr>"
  strTable = strTable & "<tr><td>݂̃[U[</td><td>" & GetCurrentUserName & "</td></tr>"
  strTable = strTable & "<tr><td>BaseDN</td><td>" & GetDomainNamingContext & "</td></tr>"
  strTable = strTable & "<tr><td>hC̋@\x</td><td>" & GetDomainFunctionalLevelToString & "</td></tr>"
  strTable = strTable & "<tr><td>tHXg̋@\x</td><td>" & GetForestFunctionalLevelToString & "</td></tr>"
  strTable = strTable & "</table>"
  WorkPage.innerHTML = strTable
End Sub

' ݂̃[U[擾
Function GetCurrentUserName
  GetCurrentUserName = WshShell.ExpandEnvironmentStrings("%USERNAME%")
End Function

' hC擾
Function GetDomainName
  DomainName = LCase(WshShell.ExpandEnvironmentStrings("%USERDNSDOMAIN%"))
  GetDomainName =  DomainName
End Function

' hCBaseDN擾
Function GetDomainNamingContext
  Dim objRootDSE
  Dim strDNC
  Dim arrItem, i
  On Error Resume Next
  Set objRootDSE = GetObject("LDAP://rootDSE")
  If Err.Number <> 0 Then
    strDNC = ""
    arrItem = Split(GetDomainName, ".")
    For i = 0 to UBound(arrItem)
      If i = 0 Then
        strDNC = "DC=" & arrItem(i)
      Else
        strDNC = strDNC & ",DC=" & arrItem(i)
      End If
    Next
  Else
    strDNC = objRootDSE.Get("defaultNamingContext")
  End If
  On Error Goto 0
  BaseDN = strDNC
  GetDomainNamingContext = strDNC
End Function

' AJEg
Function GetAccountDN(strAccountName)
  Dim objRS, strAccountDN
  ADOCommand.CommandText = "<LDAP://" & BaseDN & ">;" & _
	"(sAMAccountName=" & Left(strAccountName,20) & ");distinguishedName;subtree"
  Set objRS = ADOCommand.Execute
  strAccountDN = ""
  Do Until objRS.EOF
    strAccountDN = objRS.Fields("distinguishedName")
    objRS.MoveNext
  Loop
  GetAccountDN = strAccountDN
End Function

' [U[
Function GetUserDN(strUserName)
  Dim objRS, strUserDN
  ADOCommand.CommandText = "<LDAP://" & BaseDN & ">;" & _
	"(&(objectClass=user)(sAMAccountName=" & Left(strUserName,20) & "));distinguishedName;subtree"
  Set objRS = ADOCommand.Execute
  strUserDN = ""
  Do Until objRS.EOF
    strUserDN = objRS.Fields("distinguishedName")
    objRS.MoveNext
  Loop
  GetUserDN = strUserDN
End Function

' O[v
Function GetGroupDN(strGroupName)
  Dim objRS, strGroupDN
  ADOCommand.CommandText = "<LDAP://" & BaseDN & ">;" & _
	"(&(objectClass=group)(cn=" & strGroupName & "));distinguishedName;subtree"
  Set objRS = ADOCommand.Execute
  strGroupDN = ""
  Do Until objRS.EOF
    strGroupDN = objRS.Fields("distinguishedName")
    objRS.MoveNext
  Loop
  GetGroupDN = strGroupDN
End Function

' OU
Function GetOUDN(strOUName)
  Dim objRS, strOUDN
  ADOCommand.CommandText = "<LDAP://" & BaseDN & ">;" & _
	"(&(objectClass=organizationalUnit)(ou=" & strOUName & "));distinguishedName;subtree"
  Set objRS = ADOCommand.Execute
  strOUDN = ""
  Do Until objRS.EOF
    strOUDN = strOUDN & Chr(9) & objRS.Fields("distinguishedName")
    objRS.MoveNext
  Loop
  GetOUDN = strOUDN
End Function

' 64bitIuWFNg𕶎֕ϊ
Function GetDateTime(ByVal objDateTime)
  Dim deltaTime 
  If IsNull(objDateTime) Then ' 2000 Server ڍsĂ Null ̏ꍇ
    GetDateTime = #1/1/1601#
    Exit Function
  End If
  If objDateTime.LowPart < 0 Then
    deltaTime = objDateTime.HighPart + 1
  Else
    deltaTime = objDateTime.HighPart
  End If
  deltaTime = deltaTime * (2^32) + objDateTime.LowPart
  deltaTime = (deltaTime / (60 * 10000000) + 540) / 1440
  GetDateTime = deltaTime + #1/1/1601#
End Function

' hC̋@\x𐔒lŎ擾
Function GetDomainFunctionalLevelToInt
  Dim objDomain, intBehavior
  On Error Resume Next
  Set objDomain = GetObject("LDAP://" & BaseDN)
  If Err.Number <> 0 Then
    GetDomainFunctionalLevelToInt = -1
    Exit Function
  End If
  On Error Goto 0
  objDomain.GetInfo
  intBehavior = 0
  On Error Resume Next
  intBehavior = objDomain.Get("msDS-Behavior-Version")
  On Error Goto 0
  GetDomainFunctionalLevelToInt = intBehavior
End Function

' hC̋@\x𕶎Ŏ擾
Function GetDomainFunctionalLevelToString
  Dim intBehavior, strResult
  Dim objDomain
  intBehavior = GetDomainFunctionalLevelToInt
  If intBehavior >= 3 Then
    btnPSOSet.style.display = "inline"
  End If
  strResult = "Unknown Level " & intBehavior
  If intBehavior < 0 Then
    strResult = "hCɎQĂȂ悤ł"
  ElseIf intBehavior = 0 Then
    Set objDomain = GetObject("LDAP://" & BaseDN)
    On Error Resume Next
    intBehavior = objDomain.Get("nTMixedDomain")
    On Error Goto 0
    strResult = BehaviorVersion(0) & NativeOrMixed(intBehavior)
  ElseIf intBehavior > 0 And intBehavior <= UBound(BehaviorVersion) Then
    strResult = BehaviorVersion(intBehavior)
  End If
  GetDomainFunctionalLevelToString = strResult
End Function

' tHXg̋@\x𐔒lŎ擾
Function GetForestFunctionalLevelToInt
  Dim objDomain, intBehavior
  On Error Resume Next
  Set objDomain = GetObject("LDAP://CN=Partitions,CN=Configuration," & BaseDN)
  If Err.Number <> 0 Then
    GetForestFunctionalLevelToInt = -1
    Exit Function
  End If
  On Error Goto 0
  objDomain.GetInfo
  intBehavior = 0
  On Error Resume Next
  intBehavior = objDomain.Get("msDS-Behavior-Version")
  On Error Goto 0
  GetForestFunctionalLevelToInt = intBehavior
End Function

' tHXg̋@\x𕶎Ŏ擾
Function GetForestFunctionalLevelToString
  Dim intBehavior, strResult
  intBehavior = GetForestFunctionalLevelToInt
  strResult = "Unknown Level " & intBehavior
  If intBehavior < 0 Then
    strResult = "hCɎQĂȂ悤ł"
  ElseIf intBehavior >= 0 And intBehavior <= UBound(BehaviorVersion) Then
    strResult = BehaviorVersion(intBehavior)
  End If
  GetForestFunctionalLevelToString = strResult
End Function

' y[W[hƂ̏
Sub Window_onLoad
  Dim objWrite
  Set WshShell = CreateObject("WScript.Shell")
  Set FSO = CreateObject("Scripting.FileSystemObject")
  Set ADOConnection = CreateObject("ADODB.Connection")
  Set ADOCommand = CreateObject("ADODB.Command")
  ADOConnection.Provider = "ADsDSOObject"
  ADOConnection.Open "Active Directory Provider"
  ADOCommand.ActiveConnection = ADOConnection
  ADOCommand.Properties("Page Size") = 1000
  TopStatus
  isUpdate = False
  LogData = ""
  iTimerID = window.SetInterval("RefreshLog",1000)
  SleepVBS = FSO.GetSpecialFolder(TemporaryFolder) & "\" & FSO.GetTempName & ".vbs"
  Set objWrite = FSO.OpenTextFile(SleepVBS, ForWriting, True)
  objWrite.WriteLine "If WScript.Arguments.Count > 0 Then"
  objWrite.WriteLine "WScript.Sleep CInt(WScript.Arguments(0))"
  objWrite.WriteLine "Else"
  objWrite.WriteLine "WScript.Sleep 10"
  objWrite.WriteLine "End If"
  objWrite.Close
End Sub

Sub Window_onUnload
  ADOConnection.Close
  Set ADOCommand = Nothing
  FSO.DeleteFile SleepVBS
End Sub

Sub AddLog(strLog)
  WshShell.LogEvent evInfomation, strLog
  LogData = Now & " " & strLog & "<br>" & LogData
  isUpdate = True
End Sub

Sub AddError(strLog)
  WshShell.LogEvent evError, strLog
  strLog = "<span style=""background:#f00;color:#fff;"">" & strLog & "</span>"
  LogData = strLog & "<br>" & LogData
  isUpdate = True
End Sub

Sub AddWarning(strLog)
  WshShell.LogEvent evWarning, strLog
  strLog = "<span style=""background:#ff0;color:#000;"">" & strLog & "</span>"
  LogData = strLog & "<br>" & LogData
  isUpdate = True
End Sub

Sub ClearLog
  LogData = ""
  isUpdate = True
End Sub

Sub ChangePage( strPage )
  If strPage = "group" Then
    ExPage.style.display = "none"
    StatusPage.style.display = "none"
    UserProcPage.style.display = "none"
    GroupProcPage.style.display = "block"
    PSOPage.style.display = "none"
  ElseIf strPage = "user" Then
    ExPage.style.display = "none"
    StatusPage.style.display = "none"
    UserProcPage.style.display = "block"
    GroupProcPage.style.display = "none"
    PSOPage.style.display = "none"
  ElseIf strPage = "status" Then
    ExPage.style.display = "none"
    StatusPage.style.display = "block"
    UserProcPage.style.display = "none"
    GroupProcPage.style.display = "none"
    PSOPage.style.display = "none"
  ElseIf strPage = "pso" Then
    ExPage.innerHTML = ""
    ExPage.style.display = "block"
    StatusPage.style.display = "none"
    UserProcPage.style.display = "none"
    GroupProcPage.style.display = "none"
    PSOPage.style.display = "block"
  ElseIf strPage = "search" Or strPage = "unused" Then
    ExPage.innerHTML = ""
    ExPage.style.display = "block"
    StatusPage.style.display = "none"
    UserProcPage.style.display = "none"
    GroupProcPage.style.display = "none"
    PSOPage.style.display = "none"
  End If
  ClearLog
End Sub

Sub RefreshLog
  If isUpdate Then
    ActionLog.innerHTML = LogData
    isUpdate = False
  End If
End Sub

Sub MySleep
  WshShell.Run "wscript """ & SleepVBS & """", 0, True
End Sub

Sub MyLongSleep
  WshShell.Run "wscript """ & SleepVBS & """ 1000", 0, True
End Sub

' vf "aaa" ̗lɈ͂܂Ă aaa ɕϊ
Function StripQuote( strData )
  Dim retStr
  retStr = Trim( strData )
  If Left(retStr, 1) = Chr(34) And Right(retStr, 1) = Chr(34) Then
    retStr = Trim(Mid(strData, 2, Len(strData) - 2))
    ' ""  " ɕϊ
    retStr = Replace(retStr, """""", """")
  End If
  StripQuote = retStr
End Function
